diff -Nur irc2.10.3p7/ircd/hash.c irc2.10.3p7+hemp2+DK+B5/ircd/hash.c
--- irc2.10.3p7/ircd/hash.c	Sat Oct 11 00:32:05 2003
+++ irc2.10.3p7+hemp2+DK+B5/ircd/hash.c	Tue May 11 15:25:02 2004
@@ -29,13 +29,16 @@
 static	aHashEntry	*clientTable = NULL;
 static	aHashEntry	*channelTable = NULL;
 static	aHashEntry	*serverTable = NULL;
+static	aHashEntry	*hostnameTable = NULL;
 static	unsigned int	*hashtab = NULL;
 static	int	clhits = 0, clmiss = 0, clsize = 0;
 static	int	chhits = 0, chmiss = 0, chsize = 0;
+static	int	cnhits = 0, cnmiss = 0 ,cnsize = 0;
 static	int	svsize = 0;
 int	_HASHSIZE = 0;
 int	_CHANNELHASHSIZE = 0;
 int	_SERVERSIZE = 0;
+int	_HOSTNAMEHASHSIZE = 0;
 
 /*
  * Hashing.
@@ -74,6 +77,7 @@
 char	*nname;
 int	*store;
 {
+
 	Reg	u_char	*name = (u_char *)nname;
 	Reg	u_char	ch;
 	Reg	u_int	hash = 1;
@@ -123,6 +127,31 @@
 	return (hash);
 }
 
+
+
+/*
+ * hash_host_name
+ */
+static	u_int	hash_host_name(hname, store)
+char	*hname;
+int	*store;
+{
+
+	Reg	u_char	*name = (u_char *)hname;
+	Reg	u_int	hash = 0;
+	
+	for (; *name; name++)
+	{
+		hash = 31 * hash + hashtab[*name];
+	}
+	
+	if (store)
+		*store = hash;
+	hash %= _HOSTNAMEHASHSIZE;
+	return (hash);
+}
+
+
 /* bigger prime
  *
  * given a positive integer, return a prime number that's larger
@@ -195,6 +224,21 @@
 	Debug((DEBUG_DEBUG, "Channel Hash Table Init: %d (%d)",
 		_CHANNELHASHSIZE, size));
 }
+static	void	clear_hostname_hash_table(size)
+int	size;
+{
+	_HOSTNAMEHASHSIZE = bigger_prime(size);
+	cnhits = 0;
+	cnmiss = 0;
+	cnsize = 0;
+	if (!hostnameTable)
+		hostnameTable = (aHashEntry *)MyMalloc(_HOSTNAMEHASHSIZE *
+						     sizeof(aHashEntry));
+	bzero((char *)hostnameTable, sizeof(aHashEntry) * _HOSTNAMEHASHSIZE);
+	Debug((DEBUG_DEBUG, "Client Hash Table Init: %d (%d)",
+		_HOSTNAMEHASHSIZE, size));
+}
+
 
 static	void	clear_server_hash_table(size)
 int	size;
@@ -218,6 +262,7 @@
                                  : CHANNELHASHSIZE);
 	clear_server_hash_table((_SERVERSIZE) ? _SERVERSIZE : SERVERSIZE);
 
+	clear_hostname_hash_table((_HOSTNAMEHASHSIZE) ? _HOSTNAMEHASHSIZE : HOSTNAMEHASHSIZE);
 	/*
 	 * Moved multiplication out from the hashfunctions and into
 	 * a pre-generated lookup table. Should save some CPU usage
@@ -236,6 +281,8 @@
 	Reg	aClient	*cptr;
 	Reg	aChannel *chptr;
 	Reg	aServer	*sptr;
+	Reg	anUser	*user;
+
 	aHashEntry	*otab = table;
 	int	osize = *size;
 
@@ -282,19 +329,44 @@
 		clhits = 0;
 		clsize = 0;
 		clientTable = table;
-
+		
 		for (i = 0; i < osize; i++)
 		    {
 			for (cptr = (aClient *)otab[i].list; cptr;
 				cptr = next)
 			    {
 				next = cptr->hnext;
-				(void)add_to_client_hash_table(cptr->name, 
+				(void)add_to_client_hash_table(cptr->name,
 					cptr);
 			    }
 		    }
 		MyFree(otab);
 	    }
+	else if (otab == hostnameTable)
+	    {
+		int	i;
+		anUser	*next;
+		Debug((DEBUG_ERROR, "Hostname Hash Table from %d to %d (%d)",
+			    osize, new, clsize));
+		sendto_flag(SCH_HASH, "Hostname Hash Table from %d to %d (%d)",
+			    osize, new, clsize);
+		cnmiss = 0;
+		cnhits = 0;
+		cnsize = 0;
+		hostnameTable = table;
+
+		for (i = 0; i < osize; i++)
+		    {
+			for (user = (anUser *)otab[i].list; user;
+				user = next)
+			    {
+				next = user->hnext;
+				(void)add_to_hostname_hash_table(user->host,
+					user);
+			    }
+		    }
+		MyFree(otab);
+	    }
 	else if (otab == serverTable)
 	    {
 		Debug((DEBUG_ERROR, "Server Hash Table from %d to %d (%d)",
@@ -352,6 +424,26 @@
 }
 
 /*
+ * add_to_client_hash_table
+ */
+int	add_to_hostname_hash_table(hostname, user)
+char	*hostname;
+anUser	*user;
+{
+	Reg	u_int	hashv;
+
+	hashv = hash_host_name(hostname, &user->hashv);
+	user->hnext = (anUser *)hostnameTable[hashv].list;
+	hostnameTable[hashv].list = (void *)user;
+	hostnameTable[hashv].links++;
+	hostnameTable[hashv].hits++;
+	cnsize++;
+	if (cnsize > _HOSTNAMEHASHSIZE)
+		bigger_hash_table(&_HOSTNAMEHASHSIZE, hostnameTable, 0);
+	return 0;
+}
+
+/*
  * add_to_server_hash_table
  */
 int	add_to_server_hash_table(sptr, cptr)
@@ -456,7 +548,49 @@
 	    }
 	return 0;
 }
+/*
+ * del_from_hostname_hash_table
+ */
+int	del_from_hostname_hash_table(hostname, user)
+char	*hostname;
+anUser	*user;
+{
+	Reg	anUser	*tmp, *prev = NULL;
+	Reg	u_int	hashv;
 
+	hashv = user->hashv;
+	hashv %= _HOSTNAMEHASHSIZE;
+	for (tmp = (anUser *)hostnameTable[hashv].list; tmp; tmp = tmp->hnext)
+	    {
+		if (tmp == user)
+		    {
+			if (prev)
+				prev->hnext = tmp->hnext;
+			else
+				hostnameTable[hashv].list = (void *)tmp->hnext;
+			tmp->hnext = NULL;
+			if (hostnameTable[hashv].links > 0)
+			    {
+				hostnameTable[hashv].links--;
+				cnsize--;
+				return 1;
+			    }
+			else
+			    {
+				sendto_flag(SCH_ERROR, "hn-hash table failure");
+				Debug((DEBUG_ERROR, "hn-hash table failure")); 
+				/*
+				 * Should never actually return from here and
+				 * if we do it is an error/inconsistency in the
+				 * hash table.
+				 */
+				return -1;
+			    }
+		    }
+		prev = tmp;
+	    }
+	return 0;
+}
 
 /*
  * del_from_server_hash_table
@@ -649,6 +783,30 @@
 	chmiss++;
 	return chptr;
 }
+/*
+ * hash_find_hostname
+ */
+anUser		*hash_find_hostname(hostname, user)
+char	*hostname;
+anUser	*user;
+{
+	Reg	anUser	*tmp, *prv = NULL;
+	Reg	aHashEntry	*tmp3;
+	u_int	hashv, hv;
+
+	hashv = hash_host_name(hostname, &hv);
+	tmp3 = &hostnameTable[hashv];
+
+	for (tmp = (anUser *)tmp3->list; tmp; prv = tmp, tmp = tmp->hnext)
+		if (hv == tmp->hashv && !mycmp(hostname, tmp->host))
+		    {
+			cnhits++;
+			return (tmp);
+		    }
+	cnmiss++;
+	return user;
+}
+
 
 /*
  * hash_find_channels
@@ -746,14 +904,23 @@
 
 	if (parc > 1) {
 		ch = *parv[1];
-		if (islower(ch))
-			table = clientTable;
-		else {
-			table = channelTable;
-			size = _CHANNELHASHSIZE;
+		switch (tolower(ch))
+		{
+			case 'c':
+				table = channelTable;
+				size = _CHANNELHASHSIZE;
+				break;
+			case 'q':
+				table = hostnameTable;
+				size = _HOSTNAMEHASHSIZE;
+				break;
+			default:
+				table = clientTable;
 		}
-		if (ch == 'L' || ch == 'l')
+		if (isupper(ch))
+		{
 			showlist = 1;
+		}
 	} else {
 		ch = '\0';
 		table = clientTable;
@@ -950,6 +1117,8 @@
 		   parv[0], clhits, clmiss);
 	sendto_one(sptr,"NOTICE %s :Channel hits %d miss %d",
 		   parv[0], chhits, chmiss);
+	sendto_one(sptr,"NOTICE %s :Hostnames hits %d miss %d",
+		   parv[0], cnhits, cnmiss);
 	return 2;
 #endif
 }
diff -Nur irc2.10.3p7/ircd/hash_def.h irc2.10.3p7+hemp2+DK+B5/ircd/hash_def.h
--- irc2.10.3p7/ircd/hash_def.h	Wed Sep  3 19:45:50 1997
+++ irc2.10.3p7+hemp2+DK+B5/ircd/hash_def.h	Tue May 11 15:25:02 2004
@@ -30,3 +30,5 @@
 #define	HASHSIZE	((int)((float)MAXCONNECTIONS*1.75))
 #define	CHANNELHASHSIZE	((int)(((float)MAXCONNECTIONS*1.75)/2.0))
 #define	SERVERSIZE	(MAXCONNECTIONS/10)
+#define HOSTNAMEHASHSIZE ((int)((float)MAXCONNECTIONS*1.75))
+
diff -Nur irc2.10.3p7/ircd/hash_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/hash_ext.h
--- irc2.10.3p7/ircd/hash_ext.h	Sun Jan 17 02:13:54 1999
+++ irc2.10.3p7+hemp2+DK+B5/ircd/hash_ext.h	Tue May 11 15:25:02 2004
@@ -40,10 +40,13 @@
 EXTERN int add_to_client_hash_table __P((char *name, aClient *cptr));
 EXTERN int add_to_channel_hash_table __P((char *name, aChannel *chptr));
 EXTERN int add_to_server_hash_table __P((aServer *sptr, aClient *cptr));
+EXTERN int add_to_hostname_hash_table __P((char *hostname, anUser *user));
 EXTERN int del_from_client_hash_table __P((char *name, aClient *cptr));
 EXTERN int del_from_channel_hash_table __P((char *name, aChannel *chptr));
 EXTERN int del_from_server_hash_table __P((aServer *sptr, aClient *cptr));
+EXTERN int del_from_hostname_hash_table __P((char *hostname, anUser *user));
 EXTERN aClient *hash_find_client __P((char *name, aClient *cptr));
+EXTERN anUser *hash_find_hostname __P((char *hostname, anUser *user));
 EXTERN aClient *hash_find_server __P((char *server, aClient *cptr));
 EXTERN aChannel *hash_find_channel __P((char *name, aChannel *chptr));
 EXTERN aChannel *hash_find_channels __P((char *name, aChannel *chptr));
diff -Nur irc2.10.3p7/ircd/ircd.c irc2.10.3p7+hemp2+DK+B5/ircd/ircd.c
--- irc2.10.3p7/ircd/ircd.c	Sun May  9 22:09:08 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/ircd.c	Tue May 11 15:25:03 2004
@@ -33,7 +33,13 @@
 
 static	void	open_debugfile(), setup_signals(), io_loop();
 
+#if defined(OPER_KLINE)  || defined(LOCOP_KLINE) || \
+    defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+int	kline_added = 0;
+#endif
+
 istat_t	istat;
+iconf_t iconf;
 char	**myargv;
 int	rehashed = 0;
 int	portnum = -1;		    /* Server port number, listening this */
@@ -43,6 +49,7 @@
 char	*debugmode = "";		/*  -"-    -"-   -"-   -"- */
 char	*sbrk0;				/* initial sbrk(0) */
 char	*tunefile = IRCDTUNE_PATH;
+int 	initialconf = 1;
 static	int	dorehash = 0,
 		dorestart = 0,
 		restart_iauth = 0;
@@ -54,6 +61,10 @@
 time_t	nextexpire = 1;		/* next expire run on the dns cache */
 time_t	nextiarestart = 1;	/* next time to check if iauth is alive */
 
+#ifdef DELAY_CLOSE
+time_t nextdelayclose = 0;
+#endif
+
 #ifdef	PROFIL
 extern	etext();
 
@@ -343,17 +354,243 @@
 			return;
 		    }
 }
+#ifdef DELAY_CLOSE
+time_t  delay_close(fd,reason)
+int fd;
+char *reason;
+{
+        struct fdlog
+        {
+                struct fdlog *next;
+                int fd;
+                time_t time;
+                char reason[BUFSIZE];
+        };
+       static struct fdlog *first = NULL, *last = NULL;
+       static int delayedfdnum = 0;
+       struct fdlog *next = first, *tmp;
+
+       while (tmp = next)
+               if ((fd == -2) || (delayedfdnum == MAXCONNECTIONS / 10)
+                        || tmp->time + DELAYCLOSETIME < timeofday)
+                   {
+                       next = tmp->next;
+                       if (*(tmp->reason))
+                       {
+                                send(tmp->fd,tmp->reason,strlen(tmp->reason),0);
+                       }
+                       close(tmp->fd);
+                       delayedfdnum--;
+                       MyFree(tmp);
+                       if (!next)
+                           {
+                               if (first != last)
+                                       abort();
+                               first = last = NULL;
+                               break;
+                           }
+                       first = next;
+                   }
+               else
+                       break;
+
+       if (fd == -2)
+       {
+               nextdelayclose = 0;
+               return 0;
+       }
+       if (fd < 0)
+                return first ? first->time + DELAYCLOSETIME : 0;
+       /* disallow further receives */
+       /* this should be shutdown(fd, SHUT_RD) but some OSes do-
+         * not define this. Check shutdown(2) if it matches.
+        *                                              -- Beeth
+         */
+#ifndef SHUT_RD
+#define SHUT_RD 0
+#endif
+       shutdown(fd, SHUT_RD);
+
+       /* first create a new entry with fd and time */
+       tmp = (struct fdlog *)MyMalloc(sizeof(*tmp));
+       tmp->next = NULL;
+       tmp->fd = fd;
+       tmp->time = timeofday;
+       if (reason)
+       {
+               strncpy(tmp->reason,reason,BUFSIZE-3);
+               tmp->reason[BUFSIZE-3] = 0;
+               strcat(tmp->reason,"\r\n");
+       }
+       delayedfdnum++;
+        istat.is_delayclosed++;
+       /* then add it to the list */
+       if (last)
+           {
+               last->next = tmp;
+               last = tmp;
+           }
+       else
+               first = last = tmp;
+
+       nextdelayclose = first ? first->time + DELAYCLOSETIME : 0;
+       return nextdelayclose;
+
+}
+
+#endif /* DELAY_CLOSE */
+
+#if defined(OPER_KLINE) || defined(LOCOP_KLINE) || \
+   defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+void	check_klines(void)
+{
+	Reg aClient	*cptr;
+	int		kflag, i;
+	char		*reason;
+
+	kline_added=0;
+
+	for (i = highest_fd ; i>=0; i--)
+	    {
+
+		if (!(cptr = local[i]) || IsListening(cptr) || IsLog(cptr) ||
+		    IsHeld(cptr))
+			continue;
+#ifdef ILINE_FLAGS
+		if (IsKlineExempt(cptr))
+		{
+			continue;
+		}
+#endif
+		if ( IsPerson(cptr)
+#ifdef ILINE_FLAGS
+		&& !IsKlineExempt(cptr)
+#endif
+		   )
+		    {
+			kflag = find_kill(cptr, &reason);
+		    }
+		else
+		   {
+			kflag = 0;
+			reason = NULL;
+		   }
+
+		if (kflag && IsPerson(cptr))
+		    {
+			char buf[100];
+
+			sendto_flag(SCH_NOTICE,
+				    "Kill line active for %s",
+				    get_client_name(cptr, FALSE));
+			cptr->exitc = EXITC_KLINE;
+			if (reason)
+				sprintf(buf, "Kill line active: %.80s",
+					reason);
+			(void)exit_client(cptr, cptr, &me, (reason) ?
+					  buf : "Kill line active");
+		    }
+	    }
+
+	return;
+}
+#endif
+
+/* Checks all clients against KILL lines. (And remove them, if found.)
+** Only MAXDELAYEDKILLS at a time or all, if not defined.
+** Returns 1, if still work to do, 0 if finished.
+*/
+int delayed_kills(time_t currenttime)
+{
+	static	time_t	dk_rehashed = 0;	/* time of last rehash we're processing */
+	static	int	dk_lastfd;		/* fd we last checked */
+	static	int	dk_checked;		/* # clients we checked */
+	static	int	dk_killed;		/* # clients we killed */
+	Reg	aClient	*cptr;
+	Reg	int	i, j;
+
+	if (dk_rehashed == 0)
+	{
+		dk_rehashed = currenttime;
+		dk_checked = 0;
+		dk_killed = 0;
+		dk_lastfd = highest_fd;
+		Debug((DEBUG_DEBUG, "DK start lastfd %d", dk_lastfd));
+	}
+#ifdef MAXDELAYEDKILLS
+	/* checking only this many clients each time */
+	j = dk_lastfd - MAXDELAYEDKILLS + 1;
+	if (j < 0)
+#endif
+		j = 0;
+
+	for (i = dk_lastfd; i >= j; i--)
+	{
+		int kflag = 0;
+		char	*reason = NULL;
+
+		if (!(cptr = local[i]) || !IsPerson(cptr))
+		{
+			/* for K:lines we're interested only in local,
+			** fully registered clients */
+			if (j > 0)
+				j--;
+			continue;
+		}
+
+		/* let's count only local clients */
+		dk_checked++;
+#ifdef ILINE_FLAGS
+		if (IsKlineExempt(cptr))
+		{
+			continue;
+		}
+#endif
+
+		/* Check the client */
+		kflag = find_kill(cptr, &reason);
 
+		/* If the client is a user and a KILL line was found
+		** to be active, close this connection. */
+		if (kflag == -1)
+		{
+			char buf[100];
+
+			dk_killed++;
+			sendto_flag(SCH_NOTICE,
+				"Kill line active for %s",
+				get_client_name(cptr, FALSE));
+				cptr->exitc = EXITC_KLINE;
+			if (!BadPtr(reason))
+				sprintf(buf, "Kill line active: %.80s",
+						reason);
+			(void)exit_client(cptr, cptr, &me, (reason) ?
+					  buf : "Kill line active");
+		}
+	}
+	dk_lastfd = i;	/* from which fd to start next time */
+	Debug((DEBUG_DEBUG, "DelayedKills killed %d and counting...",
+		dk_killed));
+
+	if (dk_lastfd < 0)
+	{
+		sendto_flag(SCH_NOTICE, "DelayedKills checked %d killed %d "
+			"in %d sec", dk_checked, dk_killed,
+			currenttime - dk_rehashed);
+		dk_rehashed = 0;
+		if (rehashed == 2)
+			return 1;
+		return 0;
+	}
+	return 1;
+}
 
 static	time_t	check_pings(currenttime)
 time_t	currenttime;
 {
-	static	time_t	lkill = 0;
 	Reg	aClient	*cptr;
-	Reg	int	kflag = 0;
-	int	ping = 0, i, rflag = 0;
+	int	ping = 0, i;
 	time_t	oldest = 0, timeout;
-	char	*reason;
 
 	for (i = highest_fd; i >= 0; i--)
 	    {
@@ -361,48 +598,23 @@
 		    IsHeld(cptr))
 			continue;
 
-		/*
-		 * K and R lines once per minute, max.  This is the max.
-		 * granularity in K-lines anyway (with time field).
-		 */
-		if (
-#if defined(TIMEDKLINES) || ( defined(R_LINES) && defined(R_LINES_OFTEN) )
-			(currenttime - lkill > TIMEDKLINES) || 
-#endif /* TIMEDKLINES */
-			rehashed)
-		    {
-			if (IsPerson(cptr))
-			    {
-				kflag = find_kill(cptr, rehashed, &reason);
-#ifdef R_LINES_OFTEN
-				rflag = find_restrict(cptr);
-#endif
-			    }
-			else
-			    {
-				kflag = rflag = 0;
-				reason = NULL;
-			    }
-		    }
 		ping = IsRegistered(cptr) ? get_client_ping(cptr) :
 					    ACCEPTTIMEOUT;
-		Debug((DEBUG_DEBUG, "c(%s) %d p %d k %d r %d a %d",
-			cptr->name, cptr->status, ping, kflag, rflag,
+		Debug((DEBUG_DEBUG, "c(%s) %d p %d a %d",
+			cptr->name, cptr->status, ping,
 			currenttime - cptr->lasttime));
 		/*
 		 * Ok, so goto's are ugly and can be avoided here but this code
 		 * is already indented enough so I think its justified. -avalon
 		 */
-		if (!kflag && !rflag && IsRegistered(cptr) &&
+		if (IsRegistered(cptr) &&
 		    (ping >= currenttime - cptr->lasttime))
 			goto ping_timeout;
 		/*
 		 * If the server hasnt talked to us in 2*ping seconds
 		 * and it has a ping time, then close its connection.
-		 * If the client is a user and a KILL line was found
-		 * to be active, close this connection too.
 		 */
-		if (kflag || rflag ||
+		if (
 		    ((currenttime - cptr->lasttime) >= (2 * ping) &&
 		     (cptr->flags & FLAGS_PINGSENT)) ||
 		    (!IsRegistered(cptr) &&
@@ -472,43 +684,8 @@
 				sendto_flag(SCH_NOTICE,
 					    "No response from %s closing link",
 					    get_client_name(cptr, FALSE));
-			/*
-			 * this is used for KILL lines with time restrictions
-			 * on them - send a messgae to the user being killed
-			 * first.
-			 */
-			if (kflag && IsPerson(cptr))
-			    {
-				char buf[100];
-
-				sendto_flag(SCH_NOTICE,
-					    "Kill line active for %s",
-					    get_client_name(cptr, FALSE));
-				cptr->exitc = EXITC_KLINE;
-				if (!BadPtr(reason))
-					sprintf(buf, "Kill line active: %.80s",
-						reason);
-				(void)exit_client(cptr, cptr, &me, (reason) ?
-						  buf : "Kill line active");
-			    }
-
-#if defined(R_LINES) && defined(R_LINES_OFTEN)
-			else if (IsPerson(cptr) && rflag)
-			    {
-				sendto_flag(SCH_NOTICE,
-					   "Restricting %s, closing link.",
-					   get_client_name(cptr,FALSE));
-				cptr->exitc = EXITC_RLINE;
-				(void)exit_client(cptr, cptr, &me,
-						  "Restricting");
-			    }
-#endif
-			else
-			    {
-				cptr->exitc = EXITC_PING;
-				(void)exit_client(cptr, cptr, &me,
-						  "Ping timeout");
-			    }
+			cptr->exitc = EXITC_PING;
+			(void)exit_client(cptr, cptr, &me, "Ping timeout");
 			continue;
 		    }
 		else if (IsRegistered(cptr) &&
@@ -531,8 +708,6 @@
 		if (timeout < oldest || !oldest)
 			oldest = timeout;
 	    }
-	if (currenttime - lkill > 60)
-		lkill = currenttime;
 	if (!oldest || oldest < currenttime)
 		oldest = currenttime + PINGFREQUENCY;
 	if (oldest < currenttime + 2)
@@ -686,7 +861,9 @@
 	bzero((char *)&me, sizeof(me));
 
 	version = make_version();	/* Generate readable version string */
-
+#ifdef SEND_ISUPPORT
+	isupport = make_isupport();	/* generate 005 numeric */
+#endif
 	/*
 	** All command line parameters have the syntax "-fstring"
 	** or "-f string" (e.g. the space is optional). String may
@@ -914,7 +1091,7 @@
 		if (!find_me())
 			exit(-1);
 	    }
-
+	initialconf = 0;
 	dbuf_init();
 	setup_me(&me);
 	check_class();
@@ -990,7 +1167,11 @@
 	** active C lines, this call to Tryconnections is
 	** made once only; it will return 0. - avalon
 	*/
+#ifdef OPER_SET
+	if (iconf.aconnect && nextconnect && timeofday >= nextconnect)
+#else
 	if (nextconnect && timeofday >= nextconnect)
+#endif	
 		nextconnect = try_connections(timeofday);
 	/*
 	** Every once in a while, hunt channel structures that
@@ -1069,8 +1250,24 @@
 	if (timeofday >= nextping)
 	    {
 		nextping = check_pings(timeofday);
-		rehashed = 0;
+		if (rehashed > 0)
+		{
+			rehashed = delayed_kills(timeofday);
+		}
 	    }
+
+#ifdef DELAY_CLOSE
+        if (nextdelayclose && (timeofday >= nextdelayclose))
+        {
+                nextdelayclose = delay_close(-1,NULL);
+        }
+#endif
+
+#if defined(OPER_KLINE)  || defined(LOCOP_KLINE) || \
+    defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+	if (kline_added)
+		check_klines();
+#endif
 
 	if (dorestart)
 		restart("Caught SIGINT");
diff -Nur irc2.10.3p7/ircd/ircd_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/ircd_ext.h
--- irc2.10.3p7/ircd/ircd_ext.h	Fri Feb 12 05:00:47 1999
+++ irc2.10.3p7+hemp2+DK+B5/ircd/ircd_ext.h	Tue May 11 15:25:03 2004
@@ -27,6 +27,7 @@
 extern aClient me;
 extern aClient *client;
 extern istat_t istat;
+extern iconf_t iconf;
 extern char **myargv;
 extern int rehashed;
 extern int portnum;
@@ -41,6 +42,10 @@
 extern time_t nextping;
 extern time_t nextdnscheck;
 extern time_t nextexpire;
+extern int initialconf;
+#ifdef DELAY_CLOSE
+extern time_t nextdelayclose;
+#endif
 #endif /* IRCD_C */
 
 /*  External definitions for global functions.
@@ -59,4 +64,7 @@
 EXTERN void server_reboot();
 EXTERN void ircd_writetune __P((char *filename));
 EXTERN void ircd_readtune __P((char *filename));
+#ifdef DELAY_CLOSE
+EXTERN time_t delay_close __P((int fd,char *reason));
+#endif
 #undef EXTERN
diff -Nur irc2.10.3p7/ircd/list.c irc2.10.3p7+hemp2+DK+B5/ircd/list.c
--- irc2.10.3p7/ircd/list.c	Sun May  9 21:30:27 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/list.c	Tue May 11 15:25:03 2004
@@ -147,6 +147,11 @@
 		istat.is_auth -= 1;
 		MyFree(cptr->auth);
 	}
+	if (cptr->hopcount == 0)
+	{
+		if (cptr->reason)
+			MyFree(cptr->reason);
+	}
 	MyFree((char *)cptr);
 }
 
@@ -190,6 +195,7 @@
 	if (!serv)
 	    {
 		serv = (aServer *)MyMalloc(sizeof(aServer));
+		memset((char *) serv, 0, sizeof(aServer));
 #ifdef	DEBUGMODE
 		servs.inuse++;
 #endif
@@ -201,8 +207,11 @@
 		serv->up = NULL;
 		serv->refcnt = 1;
 		serv->nexts = NULL;
+#ifdef	SERVER_MAP
+		serv->down = NULL;
+#endif
 		cptr->serv = serv;
-
+		bzero((void *)serv->usercnt,3*sizeof(int));
 		for (sp = svrtop; sp; spp = sp, sp = sp->nexts)
 			if (spp && ((spp->ltok) + 1 < sp->ltok))
 				break;
@@ -309,6 +318,10 @@
 				    cptr, cptr ? cptr->name : "<noname>", buf);
 #endif
 		    }
+		if (serv->up && serv->up != ME)
+		{
+			MyFree((char *)serv->up);
+		}
 		MyFree((char *)serv);
 	    }
 }
@@ -499,6 +512,18 @@
 	return lp;
 }
 
+invLink	*make_invlink()
+{
+	Reg	invLink	*lp;
+
+	lp = (invLink *)MyMalloc(sizeof(invLink));
+#ifdef	DEBUGMODE
+	links.inuse++;
+#endif
+	lp->flags = 0;
+	return lp;
+}
+
 void	free_link(lp)
 Reg	Link	*lp;
 {
@@ -508,6 +533,14 @@
 #endif
 }
 
+void	free_invlink(lp)
+Reg	invLink	*lp;
+{
+	MyFree((char *)lp);
+#ifdef	DEBUGMODE
+	links.inuse--;
+#endif
+}
 
 aClass	*make_class()
 {
@@ -549,6 +582,7 @@
 	aconf->status = CONF_ILLEGAL;
 	aconf->pref = -1;
 	aconf->hold = time(NULL);
+	aconf->source_ip = NULL;
 	Class(aconf) = NULL;
 	return (aconf);
 }
@@ -586,6 +620,8 @@
 		bzero(aconf->passwd, strlen(aconf->passwd));
 	if (aconf->ping)
 		MyFree((char *)aconf->ping);
+	if (aconf->source_ip)
+		MyFree(aconf->source_ip);
 	MyFree(aconf->passwd);
 	MyFree(aconf->name);
 	MyFree((char *)aconf);
diff -Nur irc2.10.3p7/ircd/list_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/list_ext.h
--- irc2.10.3p7/ircd/list_ext.h	Fri Jul  2 18:49:37 1999
+++ irc2.10.3p7+hemp2+DK+B5/ircd/list_ext.h	Tue May 11 15:25:03 2004
@@ -55,7 +55,9 @@
 EXTERN Link *find_user_link __P((Reg Link *lp, Reg aClient *ptr));
 EXTERN Link *find_channel_link __P((Reg Link *lp, Reg aChannel *ptr));
 EXTERN Link *make_link();
+EXTERN invLink *make_invlink();
 EXTERN void free_link __P((Reg Link *lp));
+EXTERN void free_invlink __P((Reg invLink *lp));
 EXTERN aClass *make_class();
 EXTERN void free_class __P((Reg aClass *tmp));
 EXTERN aConfItem *make_conf();
diff -Nur irc2.10.3p7/ircd/res.c irc2.10.3p7+hemp2+DK+B5/ircd/res.c
--- irc2.10.3p7/ircd/res.c	Sun May  9 21:59:00 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/res.c	Tue May 11 15:25:03 2004
@@ -512,7 +512,8 @@
 		(u_int)(cp[1]&0xf), (u_int)(cp[1]>>4),
 		(u_int)(cp[0]&0xf), (u_int)(cp[0]>>4),
 #ifdef SIXBONE_HACK
-		(cp[0] == 0x3f && cp[1] == 0xfe) ? "int" :
+		((cp[0] == 0x3f && cp[1] == 0xfe) ||
+		 (cp[0] == 0x20 && cp[1] == 0x02)) ? "int" :
 #endif
 		"arpa");
 	    }
diff -Nur irc2.10.3p7/ircd/s_auth.c irc2.10.3p7+hemp2+DK+B5/ircd/s_auth.c
--- irc2.10.3p7/ircd/s_auth.c	Sat Oct 11 22:04:29 2003
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_auth.c	Tue May 11 15:25:03 2004
@@ -291,15 +291,15 @@
 				}
 			    iauth_stats = (aExtData *)
 				    MyMalloc(sizeof(aExtData));
-			    iauth_stats->line = MyMalloc(60);
+			    iauth_stats->line = MyMalloc(80);
 			    sprintf(iauth_stats->line,
 				    "iauth modules statistics (%s)",
 				    myctime(timeofday));
 			    iauth_stats->next = (aExtData *)
 				    MyMalloc(sizeof(aExtData));
-			    iauth_stats->next->line = MyMalloc(60);
+			    iauth_stats->next->line = MyMalloc(80);
 			    sprintf(iauth_stats->next->line,
-				    "spawned: %d, current options: %X (%.11s)",
+				    "spawned: %d, current options: %X (%.20s)",
 				    iauth_spawn, iauth_options,
 				    (iauth_version) ? iauth_version : "???");
 			    iauth_stats->next->next = NULL;
@@ -459,6 +459,13 @@
 			    ** yet: we don't even know if this is a server
 			    ** or a user connection!
 			    */
+			    int i;
+			    char *reason;
+			    reason = strchr(start,'#');
+			    if (reason)
+			    {
+				    cptr->reason = mystrdup(reason+1);
+			    }
 			    if (start[0] == 'K')
 				    cptr->exitc = EXITC_AREF;
 			    else
diff -Nur irc2.10.3p7/ircd/s_bsd.c irc2.10.3p7+hemp2+DK+B5/ircd/s_bsd.c
--- irc2.10.3p7/ircd/s_bsd.c	Sun May  9 22:24:07 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_bsd.c	Tue May 11 15:25:03 2004
@@ -341,7 +341,32 @@
 		free_client(cptr);
 	return 0;
 }
-
+#ifdef DELAY_ACCEPT
+void activate_delayed_listeners()
+{
+	aConfItem *aconf = NULL;
+	int pcnt = 0;
+	
+	for (aconf = conf; aconf; aconf = aconf->next)
+	{
+		if (!(aconf->status & CONF_LISTEN_PORT)
+				|| (conf->status & CONF_ILLEGAL))
+		{
+			continue;
+		}
+		if (!(aconf->status & CONF_ACTIVE))
+		{
+			aconf->status |= CONF_ACTIVE;
+			pcnt++;
+			add_listener(aconf);
+		}
+	}
+	if (pcnt)
+	{
+		sendto_flag(SCH_NOTICE,"Activating delayed listening ports");
+	}
+}
+#endif
 #ifdef	UNIXPORT
 /*
  * unixport
@@ -1360,8 +1385,21 @@
 		    }
 		del_fd(i, &fdall);
 		local[i] = NULL;
-		(void)close(i);
-
+#ifdef DELAY_CLOSE
+                if (cptr->user && (cptr->user->flags & FLAGS_BADBOY))
+                {
+                        delay_close(i,cptr->buffer);
+                        if (!nextdelayclose)
+                        {
+                                nextdelayclose = timeofday + DELAYCLOSETIME;
+                        }
+                }
+                else
+#endif
+		{
+			(void)close(i);
+		}
+		
 		cptr->fd = -2;
 		DBufClear(&cptr->sendQ);
 		DBufClear(&cptr->recvQ);
@@ -1620,15 +1658,23 @@
 				report_error("Failed in connecting to %s :%s",
 					     cptr);
 add_con_refuse:
+			(void)close(fd);
+add_con_delay_refuse:
 			ircstp->is_ref++;
 			acptr->fd = -2;
 			free_client(acptr);
-			(void)close(fd);
 			return NULL;
 		    }
 		/* don't want to add "Failed in connecting to" here.. */
 		if (aconf && IsIllegal(aconf))
 			goto add_con_refuse;
+#ifdef DELAY_ACCEPT
+		/* we are not accepting connections because of split */
+		if (aconf && (aconf->status & CONF_DELAY) && (iconf.caccept < 2))
+		{
+			goto add_con_refuse;
+		}
+#endif
 		/* Copy ascii address to 'sockhost' just in case. Then we
 		 * have something valid to put into error messages...
 		 */
@@ -1670,10 +1716,15 @@
 			    (acptr->hostp) ? acptr->hostp->h_name :
 			    acptr->sockhost);
 		del_queries((char *)acptr);
+#ifdef DELAY_CLOSE
+		delay_close(fd,"ERROR :Too rapid connections from your host");
+		goto add_con_delay_refuse;
+#else
 		(void)send(fd,
 			   "ERROR :Too rapid connections from your host\r\n",
 			   46, 0);
 		goto add_con_refuse;
+#endif
 	    }
 #endif
 	acptr->fd = fd;
@@ -2580,6 +2631,8 @@
 int	*lenp;
 {
 	static	struct	SOCKADDR_IN	server;
+	struct SOCKADDR_IN outip;
+	
 	Reg	struct	hostent	*hp;
 	aClient	*acptr;
 	int	i;
@@ -2599,7 +2652,25 @@
 	bzero((char *)&server, sizeof(server));
 	server.SIN_FAMILY = AFINET;
 	get_sockhost(cptr, aconf->host);
-
+	
+	if (aconf->source_ip)
+	{
+		memset(&outip, 0, sizeof(outip));
+		outip.SIN_PORT = 0;
+		outip.SIN_FAMILY = AFINET;
+#ifdef INET6
+		if (!inetpton(AF_INET6, aconf->source_ip, outip.sin6_addr.s6_addr))
+#else
+		if ((outip.sin_addr.s_addr = inetaddr(aconf->source_ip)) == -1)
+#endif
+		{
+			memcpy(&mysk, &outip, sizeof(mysk));		
+		}
+	}
+	else
+	{
+		memcpy(&outip, &mysk, sizeof(mysk));		
+	}
 	if (cptr->fd == -1)
 	    {
 		report_error("opening stream socket to server %s:%s", cptr);
@@ -2611,7 +2682,7 @@
 	** with more than one IP#.
 	** With VIFs, M:line defines outgoing IP# and initialises mysk.
 	*/
-	if (bind(cptr->fd, (SAP)&mysk, sizeof(mysk)) == -1)
+	if (bind(cptr->fd, (SAP)&outip, sizeof(outip)) == -1)
 	    {
 		report_error("error binding to local port for %s:%s", cptr);
 		return NULL;
diff -Nur irc2.10.3p7/ircd/s_bsd_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/s_bsd_ext.h
--- irc2.10.3p7/ircd/s_bsd_ext.h	Fri Feb  5 00:50:21 1999
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_bsd_ext.h	Tue May 11 15:25:03 2004
@@ -61,6 +61,9 @@
 EXTERN void get_my_name __P((aClient *cptr, char *name, int len));
 EXTERN int setup_ping __P((aConfItem *aconf));
 EXTERN void send_ping __P((aConfItem *aconf));
+#ifdef DELAY_ACCEPT
+EXTERN void activate_delayed_listeners();
+#endif
 #if defined(ENABLE_SUMMON) || defined(ENABLE_USERS)
 EXTERN int utmp_open();
 EXTERN int utmp_read __P((int fd, char *name, char *line, char *host,
